View Javadoc

    1   /*
    2    * Licensed to the Apache Software Foundation (ASF) under one
    3    * or more contributor license agreements.  See the NOTICE file
    4    * distributed with this work for additional information
    5    * regarding copyright ownership.  The ASF licenses this file
    6    * to you under the Apache License, Version 2.0 (the
    7    * "License"); you may not use this file except in compliance
    8    * with the License.  You may obtain a copy of the License at
    9    *
    10   *   http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   * Unless required by applicable law or agreed to in writing,
    13   * software distributed under the License is distributed on an
    14   * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   * KIND, either express or implied.  See the License for the
    16   * specific language governing permissions and limitations
    17   * under the License.
    18   */
    19  package org.apache.mina.transport.nio;
    20
    21  import java.nio.channels.SelectableChannel;
    22
    23  /**
    24   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    25   */
    26  public interface SelectorLoop {
    27      /**
    28       * Register a channel on a Selector, for some events. We can register for OP_ACCEPT, OP_READ or OP_WRITE.
    29       *
    30       * @param accept Registers for OP_ACCEPT events
    31       * @param connect Registers for OP_CONNECT events
    32       * @param read Registers for OP_READ events
    33       * @param write Registers for OP_WRITE events
    34       * @param listener The listener
    35       * @param channel
    36       * @param wakeup Tells if we should do a wakeup() on the selector
    37       */
    38      void register(boolean accept, boolean connect, boolean read, boolean write, SelectorListener listener,
    39              SelectableChannel channel, RegistrationCallback callback);
    40
    41      void modifyRegistration(boolean accept, boolean read, boolean write, SelectorListener listener,
    42              SelectableChannel channel, boolean wakeup);
    43
    44      void unregister(SelectorListener listener, SelectableChannel channel);
    45
    46      /**
    47       * Wake up the selector
    48       */
    49      void wakeup();
    50  }